<?php

$cachedtags="amodbcachedtags";
$cachedtagsandids="amodbcachedtagsandids";

$catnames=array("adjective", "adjectivesubtag", "genre", "genresubtag", "leadinstrument", "leadinstrumentsubtag", "otherinstrument", "otherinstrumentsubtag", "other", "othersubtag", "language", "languagesubtag");

$catnums=array("1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12");

function StripRN($string)
{
   return preg_replace('/(\r\n)+|(\n|\r)+/', ' ', $string);
}

function RemoveWhitespaceEtcFromTagArr(&$arr)
{
	$arr=trim($arr);
	$arr=StripRN($arr);
	$arr=StripExtraMiddleSpaces($arr);
}
function TrimStr(&$str)
{	$str=trim($str);
}
function LowercaseArr(&$str)
{	$str=strtolower($str);
}

function TrimLastEntryOfArr(&$arr)
{
	$lastentry=array_pop($arr);	
	$lastentry=trim($lastentry);
	$lclastentry=strtolower($lastentry);
	$arr[$lclastentry]=$lastentry;
}

function StripExtraMiddleSpaces($string)
{
   return preg_replace('/\s\s+/', ' ', $string);
}


function TagCatnameToNumber($inp)
{	//Function not actually used, but I'm leaving it in since it shows you at a glance what the numbers mean.
	switch ($inp)
	{	case "adjective": return 1;
		case "adjectivesubtag": return 2;
		case "genre": return 3;
		case "genresubtag": return 4;
		case "leadinstrument": return 5;
		case "leadinstrumentsubtag": return 6;
		case "otherinstrument": return 7;
		case "otherinstrumentsubtag": return 8;
		case "other": return 9;
		case "othersubtag": return 10;
		case "language": return 11;
		case "languagesubtag": return 12;
	}
}

function GetCachedTags()
{	
	global $handle, $cachedtags, $cachedtagsandids, $array_existingtags, $array_existingtagsids, $array_existingtagsandids;

	if (!$_SESSION[$cachedtags])		//If there's no cached list of tags, we have to get
	{						//the list of tags directly from the database.
		$query_to_issue = "SELECT tag_id, tag_name FROM Tags";
		$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

		if (mysql_num_rows($query_result) > 0)

		{	$x=0;
			while ($row = mysql_fetch_array($query_result))
			{	$array_existingtags[$x]=strtolower($row[tag_name]);
				$array_existingtagsids[$x]=$row[tag_id];
			
				$x++;
			}

			//This next array is all lowercase, as is $array_existingtags:
			$array_existingtagsandids=array_combine($array_existingtags,$array_existingtagsids );
			
			$_SESSION[$cachedtags]=$array_existingtags;
			$_SESSION[$cachedtagsandids]=$array_existingtagsandids;

		}
		else
		{	$array_existingtagsandids["dummy;key"]="dummy;tag";
			$array_existingtags["dummy;key"]="dummy;tag";
			$array_existingtagsids["dummy;key"]="dummy;id";
		}
	}
	else
	{	
		$array_existingtags=$_SESSION[$cachedtags];
		$array_existingtagsandids=$_SESSION[$cachedtagsandids];
	}

}

function PrintCachedTags()
{	global $cachedtagsandids, $cachedtags;

	echo "<pre>";
	PrintArr($_SESSION[$cachedtags], "Cached tags:");
	PrintArr($_SESSION[$cachedtagsandids],"Cached tags and ids:");
	echo "<p>";
}

function CleanUpTagstring ($inp)	//Nicely formats any tagstrings input by the user,
{									//and also makes them safe for the database.

									//Seemingly not used anywhere, but, I didn't look very hard,
									//so I'm leaving it anyhow.
	$arr=explode(";",$inp);
	array_walk($arr, RemoveWhitespaceEtcFromTagArr);
	$arr=ArrRemoveEmptyValues($arr);
	
	$arr=array_iunique($arr);
	natcasesort($arr);	//To make all the array entries alphabetical.

	$inp=implode("; ",$arr);
	
	CleanInput($inp);
	return $inp;
}

function GetSubtags($tagstring)
{
	$arr=explode(";",$tagstring);
	$str=implode(" ",$arr);

	$str=preg_replace('/[-]+|[\,]+|[.]+/', ' ', $str);
	$str=trim($str);
	$str=StripRN($str);
	$str=StripExtraMiddleSpaces($str);
	
	$arr=explode(" ",$str);
	$str=implode("; ",$arr);
	return $str;
}

  
function PrintArr($arr, $text="Printed Array:")
{	//This was useful for debugging.
	//Might be good to put functions like this in some kind of library file, lib-debug.php or something.
	echo "<p><br><big><b>$text</b></big><p>";
	print_r($arr);
}

function MakeTagstringArray($tagstring)
{
	$arr=explode(";", $tagstring);
	array_walk($arr, RemoveWhitespaceEtcFromTagArr);
	$arr=ArrRemoveEmptyValues($arr);
	$arr=array_iunique($arr);
	natcasesort($arr);
	
	//This bit here is just to make the array continuous instead
	//of having gaps:
	$arr=array_merge($arr);
	
	return $arr;
}

function ManageTags($tagmaptype, $given_id)
{	global $handle, $array_existingtags, $array_existingtagsids, $array_existingtagsandids, $cachedtags, $cachedtagsandids, $changed_tagtypes, $catnames, $catnums;

	$tagmaptable=$tagmaptype . "tagmap";

	$array_catnames_and_nums=array_combine($catnames, $catnums);
	$array_catnums_and_names=array_flip($array_catnames_and_nums);
	
	GetCachedTags();	//Here, we get all the existing tags and ids.
	//PrintCachedTags();	//Then we print them.

	$num_of_existing_tags_and_ids=count($array_existingtagsandids);		//And count them.
	echo "<hr><p>Num of existing tags and ids: $num_of_existing_tags_and_ids<p>";
	PrintArr($array_existingtagsandids, "Existing tags and ids:");

	PrintArr($changed_tagtypes, "Changed Tagtypes:");
	
	$numofchangedtagtypes=count($changed_tagtypes);	//Then we find out how many tag types have been changed.

	foreach ($changed_tagtypes as $tagtype)	//Then we get all the changed tagtypes' tagstrings...
	{
		$quotelessvar="quoteless_" . $tagtype . "string";
		global ${$quotelessvar};
		$tagstring=${$quotelessvar};
		if ($tagstring)
		{	$array_of_tag_tagstrings[$tagtype] = "$tagstring; ";
			$alltagstring .= "$tagstring; ";	//...and put them all together in one large string.
		}
		
		//Then we get all the subtags out of the small tagstring.
		$subtags=GetSubtags($tagstring);
		if ($subtags)
		{	$array_of_subtag_strings[$tagtype]="$subtags; ";	//And store the subtag string in its own array entry. 
			$allsubtags .= "$subtags; ";	//...and in a large string for all subtags.
		}
	}
	
	if ($allsubtags)
	{	
		$alltagsonly=$alltagstring;
		$array_alltagsonly=MakeTagstringArray($alltagsonly);
		
		$array_allsubtags=MakeTagstringArray($allsubtags);
		
		$array_alluniquesubtags=array_diff($array_allsubtags, $array_alltagsonly);
		$array_alluniquesubtags=array_merge($array_alluniquesubtags);
		PrintArr($array_alluniquesubtags, "All unique subtags:");
		
		$alluniquesubtags=implode("; ", $array_alluniquesubtags);

		foreach ($changed_tagtypes as $tagtype)
		{	$maintagarray=MakeTagstringArray($array_of_tag_tagstrings[$tagtype]);
			$subtagarray=MakeTagstringArray($array_of_subtag_strings[$tagtype]);
			$subtagarray=array_diff($subtagarray, $maintagarray);
			$subtagarray=array_merge($subtagarray);
			
			$subtagarray=implode("; ", $subtagarray);
		
			$array_subtags[$tagtype] = "$subtagarray; ";
		}

		$alltagstring .= "$alluniquesubtags; ";		
	}

	$alltagstring=substr ($alltagstring, 0, -1);

	//This gets the tagtype_querysegment ready for any queries that need it.
	$x=0;
	$tagtype_querysegment = " tagtypenum IN (";
	
	foreach ($changed_tagtypes as $tagtype)
	{	
		$tagnum=$array_catnames_and_nums[$tagtype];
		$subtagnum=$tagnum+1;
		$tagtype_querysegment .= "$tagnum, $subtagnum, ";
		$x++;
	}
	$tagtype_querysegment=substr ($tagtype_querysegment, 0, -2);
	$tagtype_querysegment .= ")";
	
	if ($num_of_existing_tags_and_ids>0)	//Number of tags and ids in the cache of tags already in the DB.
	{ 	
		if ($alltagstring)	//If there are any tags from the changed tagtypes...
		{	$alltagstring .= "; ";
			$array_allcleantags=MakeTagstringArray($alltagstring);			
			
			$array_lowercase_allcleantags=$array_allcleantags;
			array_walk($array_lowercase_allcleantags,LowercaseArr);
			
			//Lastly, we make an associative array so we can easily match the lowercase
			//tags to the cased ones later.  The lowercase tag is the key, the
			//cased key is the value.

			$array_lowercasealltags_and_alldisplaytags=array_combine($array_lowercase_allcleantags,$array_allcleantags);
			
			//Then we make an array which is made up of all the tags
			//which are part of both the input tags and the
			//existing tags.

			//These are old tags which won't have to be re-added to the 
			//Tags table - all they need is listings in the 
			//Tagmap table.

			$array_alloldtags = array_intersect($array_lowercase_allcleantags,$array_existingtags );

			PrintArr($array_alloldtags, "Existing tags:");


			//This bit here is just to make the array continuous instead
			//of having gaps:
			$array_alloldtags=array_merge($array_alloldtags);

			
			//And here we figure out which of the tags the user put in
			//aren't existing tags.  Later, the tags listed in this
			//array will be added to the Tags table.

			$array_allnewtags = array_diff($array_lowercase_allcleantags, $array_existingtags );
			$array_allnewtags=array_merge($array_allnewtags);
			

			PrintArr($array_allnewtags, "New tags:");
		}
	}
	// If it turns out there are no existing blog tags, then, we'll set up the new tags array real easily...
	else if ($num_of_existing_tags_and_ids==0)
	{	if ($alltagstring)
		{	$array_allnewtags=$array_lowercase_allcleantags;
		}
	}
	
	echo "<p><hr><p>";
	
	//Next, we add any new tags to the Tags table.
	if ($alltagstring)
	{	
		$num_of_new_tags=count($array_allnewtags);

		if ($num_of_new_tags>0)
		{
			$x=0;

		//What we do is run through and create a multi-row INSERT
		//query consisting of every value in the array of new tags, 
		//or, to be more precise, its cased equivalent (accessed via the associative 
		//array $array_lowercasealltags_and_alldisplaytags created above).

			$insert_tags_query = "INSERT INTO Tags (tag_name) VALUES ";
			while ($x<$num_of_new_tags)
			{	$newtag=$array_allnewtags[$x];
				$insert_tags_query .= "('$array_lowercasealltags_and_alldisplaytags[$newtag]'), ";
				$x++;
			}

		//Then we chop off the final ", " so we don't get an error when we
		//issue the query.
			$insert_tags_query=substr ($insert_tags_query, 0, -2);

			echo $insert_tags_query;

			mysql_query($insert_tags_query,$handle) or die(mysql_error());


		//Then we get the ID of the first newly inserted id.  This is confusing
		//because I thought this routine retrieved the last inserted ID,
		//but for some reason it doesn't.  Still, this suffices.

			$first_inserted_id=mysql_insert_id();

			$x=0;
			$idnum=$first_inserted_id;

			//Now, we add all the newly-added tags to the arrays of existing tags.
			while ($x<$num_of_new_tags)
			{	$thistag=$array_allnewtags[$x];
				$array_existingtagsandids[$thistag]=$idnum;
				array_push($array_existingtags, $thistag);
				$idnum++;
				$x++;
			}
			
			//Then we set the session variable copies of the cached tags equal to the updated tags arrays.
			$_SESSION[$cachedtags]=$array_existingtags;
			$_SESSION[$cachedtagsandids]=$array_existingtagsandids;
		}
	}
	
	//Then we have to figure out what  tags need to be added to the tagmap for this song, if any.
	
	//We have to get the tags that are already in the tagmap so we can make sure we're not
	//making a duplicate entry.

	$query_to_issue = "SELECT tag_id, tagtypenum FROM $tagmaptable WHERE $tagmaptype" . "_id = $given_id AND ($tagtype_querysegment)";

	echo "<p>" . $query_to_issue . "<p>";

	$query_result=mysql_query($query_to_issue,$handle) or die(mysql_error());

	$num_of_tagmapped_tags=mysql_num_rows($query_result);
	
	//Then we take note of all the already-tagmapped IDs so we can figure out which
	//ones need to be added and which need to be deleted.
	//Format: $tagtypes[adjective][15], $tagtypes[adjective][42], etc.

	foreach ($changed_tagtypes as $tagtype)
	{
		if ($array_subtags[$tagtype])
		{	
			$subtagtypename=$tagtype . "subtag";
			array_push($changed_tagtypes, $subtagtypename);
			$quoteless_subtagvar="quoteless_$tagtype" . "subtagstring";
			global ${$quoteless_subtagvar};
			${$quoteless_subtagvar}=$array_subtags[$tagtype];
		}
	}
	
	foreach ($changed_tagtypes as $tagtype)
	{
		$tagtypes_and_tagmapped_ids[$tagtype]=array();	
	}
	
	if ($num_of_tagmapped_tags>0)
	{	$x=0;
		while ($x<$num_of_tagmapped_tags)
		{	$thistagtypenum=mysql_result($query_result, $x, 'tagtypenum');
			$thistagid=mysql_result($query_result, $x, 'tag_id');
			$thistagtype=$array_catnums_and_names[$thistagtypenum];
			$previouslytagmappedids[$x]=$thistagid;

			$tagtypes_and_tagmapped_ids[$thistagtype][$thistagid]=$thistagid;
			$x++;
		}
	}

	//Then, we handle each updated tagtype one at a time...

	foreach ($changed_tagtypes as $tagtype)
	{			
		$tagtypenum=$array_catnames_and_nums[$tagtype];
	
		global ${$quotelessvar};
		$quotelessvar="quoteless_" . $tagtype . "string";
		
		$tagstring=${$quotelessvar};
		
		if ($tagstring) //If there are actually tags in this updated tagtype...
		{	$lowercase_tagstring=strtolower($tagstring);	//We make them all lowercase...
			$array_lowercase_cleantags=MakeTagstringArray($lowercase_tagstring);	//And then make an array out of the string.

			$numofcandidatetags=count($array_lowercase_cleantags);
			unset($candidatetagids);
			
			$candidatetagids=array();
			if ($array_lowercase_cleantags)
			{
				$y=0;
				while ($y<$numofcandidatetags)
				{	$thistag=$array_lowercase_cleantags[$y];
					$candidatetagids[$y]=$array_existingtagsandids[$thistag];
					$y++;
				}
			}

			if ($num_of_tagmapped_tags>0)
			{
				$tagtypes_and_tagmapped_ids[$tagtype]=array_merge($tagtypes_and_tagmapped_ids[$tagtype]);
				if (is_array($tagtypes_and_tagmapped_ids[$tagtype]) )
				{
					$array_tagidsfortagmap=array_diff($candidatetagids, $tagtypes_and_tagmapped_ids[$tagtype]);
					$array_tagidsfordeletion=array_diff($tagtypes_and_tagmapped_ids[$tagtype], $candidatetagids);
					$string_tagidsfordeletion=implode(", ", $array_tagidsfordeletion);
					
				}
				else
				{	$array_tagidsfortagmap=$candidatetagids;
					//Nothing to delete!
				}

					
					if ($string_tagidsfordeletion)
					{	$num_for_deletion=count($array_tagidsfordeletion);
						$tagmap_entries_to_delete .= "(tag_id IN ($string_tagidsfordeletion) AND tagtypenum=$tagtypenum) OR ";
					}
				}
				else if ($num_of_tagmapped_tags==0)
						//If there are no tagmapped tags, that makes things easier, since we can just add
						//all the input tags to the tagmap, with none to delete.
				{	$array_tagidsfortagmap=$candidatetagids;
				}

				$numoftagsfortagmap=count($array_tagidsfortagmap);

				if ($numoftagsfortagmap>0)
				{
					foreach ($array_tagidsfortagmap as $idfortagmap)
					{	
						$new_tagmap_entries .= "($given_id, $idfortagmap, $tagtypenum), ";
					}
				}
		}
		else	//If there aren't any input tags of this updated_tagtype...
		{
			if ($num_of_tagmapped_tags>0) //...and if there are any tagmapped tags of this tagtype, we just want to get rid of them all.
			{	if ( is_array($tagtypes_and_tagmapped_ids[$tagtype]) )
				{	$subtagnum=$tagtypenum+1;
					$tagmap_entries_to_delete .= "tagtypenum='$tagtypenum' OR tagtypenum='$subtagnum' OR ";
				}
			}
		}
	}
	$new_tagmap_entries=substr ($new_tagmap_entries, 0, -2);
	
	if ($tagmap_entries_to_delete)
	{
		$tagmap_entries_to_delete=substr ($tagmap_entries_to_delete, 0, -4);
	}
	
	if ($new_tagmap_entries)
	{
		$tagmap_query_to_issue = "INSERT INTO $tagmaptable ($tagmaptype" . "_id, tag_id, tagtypenum) VALUES $new_tagmap_entries";
		echo "<p>$tagmap_query_to_issue<p>";
		$query_result=mysql_query($tagmap_query_to_issue,$handle) or die(mysql_error());
	}

	if ($tagmap_entries_to_delete)
	{
		$delete_query_to_issue="DELETE FROM $tagmaptable WHERE $tagmaptype" . "_id=$given_id AND ( $tagmap_entries_to_delete )";
		
		echo "<p>$delete_query_to_issue<p>";
		$query_result=mysql_query($delete_query_to_issue,$handle) or die(mysql_error());
	}

}

?>